//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Classe abstraite de gestion du processus.
//    v:0.1 07/09/2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package vabase;
import java.awt.*;

/**  Classe abstraite de gestion du processus */
public abstract class Cprocess implements Runnable {
  static final int TEMPO_DEFAUT=1;
  /** Pointeur sur l'interface utilisateur */
  Cui Ui;
  /** Vue */
  public Cvue vue;
  /** Processus */
  public Thread prThread;
  /** Flag en cours */
  public boolean isRunning;
  /** gnration courante */
  public int generation;
  /** Temporisation */
  int tempoProcess=TEMPO_DEFAUT;

  /** Constructeur par dfaut */
  public Cprocess() {
  }
  /** Constructeur dans une UI */
  public Cprocess(Cui ui) {
    Ui=ui;
    generation=0;
  }
  /** Dmarrage du processus */
  public void lancement() {
    if(prThread==null)
      prThread=new Thread(this);
    prThread.start();
  }
  /** Boucle principale */
  public void run() {
    Thread ceThread=Thread.currentThread();
    isRunning=true;
    while(prThread==ceThread) {
     geneSuiv();
     try {
        Thread.sleep(tempoProcess);
      } catch (InterruptedException e) { }
    }
  }
  /** Arrt boucle */
  public void stop() {
    prThread=null;
    isRunning=false;
  }
  /** Mise  jour de la valeur de temporisation */
  public void setTempo(int t) {
    tempoProcess=t;
  }
  /** Avance pas--pas */
  public void pasAPas() {
    geneSuiv();
  }
  /** Gnration suivante */
  public abstract void geneSuiv();
  /** Initialisation de la vue graphique */
  public abstract void initVue();
}
